/*****************************************************************************/
/*	aisa06w.c																 */
/*																			 */
/*	aISA-A06W/H															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/05/12															 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "aisa06w.h"	// aISA-A06W/H

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa06wGetDllExportFunc();


/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAisa06GetVersion;
static FARPROC pAisa06Create;
static FARPROC pAisa06Close;
static FARPROC pAisa06GetResource;
static FARPROC pAisa06SetData;
static FARPROC pAisa06GetCH;
static FARPROC pAisa06GetLastError;


/*****************************************************************************/
/* 	  aisa06.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA06_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (!Aisa06wGetDllExportFunc())
	{
		Aisa06wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa06.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL))
	{
		hDLL = NULL;
		return TRUE;
	}

	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-A06W/H DLL,Driver̃o[Wԍ擾						 */
/* 	  pdwDllVer DLLo[Wԍ̊i[AhX						 */
/*		  pdwDrvVer Drivero[Wԍ̊i[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa06GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-A06W/H̔Cӂ̃foCX̎gp錾							 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/*		  hWnd		bZ[W󂯎EBhEnh					 */
/*		  uWMBase	bZ[WID̊l									 */
/*		  pvInitArg ̂߂̗\										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa06Create)(pwLogSlot, hWnd, uWMBase, pvInitArg);
}

/*****************************************************************************/
/* 	  aISA-A06W/H̔Cӂ̃foCX̎gpJ							 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa06Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pResInfo \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wGetResource(WORD wLogSlot, PAISA06R_NT pResInfo)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa06GetResource)(wLogSlot, pResInfo);
}

/*****************************************************************************/
/* 	  o̓f[^̐ݒ													 */
/* 	  wLogSlot _Xbg												 */
/*		  wChData  ݃`l(0 ` 3)									 */
/*		  wDaData  D/A݃f[^										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wSetData(WORD wLogSlot, WORD wChData, WORD wDaData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa06SetData)(wLogSlot, wChData, wDaData);
}

/*****************************************************************************/
/* 	  O͏Ԃ̎擾												 */
/* 	  wLogSlot _Xbg												 */
/*		  pdwCH1   CH1̏												 */
/*		  pdwCH2   CH2̏												 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa06wGetCH(WORD wLogSlot, PDWORD pdwCH1, PDWORD pdwCH2)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa06GetCH)(wLogSlot, pdwCH1, pdwCH2);
}

/*****************************************************************************/
/* 	  aISA-A06W/H̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa06wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA06_ERR_WRAPDLL;

	return (*pAisa06GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa06wGetDllExportFunc()
{
	// Aisa06GetVersion ̃AhX擾
	pAisa06GetVersion = GetProcAddress(hDLL, _T("Aisa06GetVersion"));
	if (pAisa06GetVersion == NULL)
		return FALSE;

	// Aisa06Create ̃AhX擾
	pAisa06Create = GetProcAddress(hDLL, _T("Aisa06Create"));
	if (pAisa06Create == NULL)
		return FALSE;

	// Aisa06Close ̃AhX擾
	pAisa06Close = GetProcAddress(hDLL, _T("Aisa06Close"));
	if (pAisa06Close == NULL)
		return FALSE;

	// Aisa06GetResource ̃AhX擾
	pAisa06GetResource = GetProcAddress(hDLL, _T("Aisa06GetResource"));
	if (pAisa06GetResource == NULL)
		return FALSE;

	// Aisa06SetData ̃AhX擾
	pAisa06SetData = GetProcAddress(hDLL, _T("Aisa06SetData"));
	if (pAisa06SetData == NULL)
		return FALSE;

	// Aisa06GetCH ̃AhX擾
	pAisa06GetCH = GetProcAddress(hDLL, _T("Aisa06GetCH"));
	if (pAisa06GetCH == NULL)
		return FALSE;

	// Aisa06GetLastError ̃AhX擾
	pAisa06GetLastError = GetProcAddress(hDLL, _T("Aisa06GetLastError"));
	if (pAisa06GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
